#include <iostream>

class Info {
	int value;

public:
	Info(int v = 0)
	    : value(v) { std::cout << value << ": constructor\n"; }
	Info(const Info& other)
	    : value(other.value) { std::cout << value << ": copy constructor\n"; }
	Info& operator=(const Info& other) {
		value = other.value;
		std::cout << value << ": copy assignment\n";
		return *this;
	}
};

void takeValue(Info i) {
	// do something with i
	std::cout << "inside takeValue\n";
}

void takeRefAndCopy(const Info& i) {
	Info j = i; // copy
	// do something with j
	std::cout << "inside takeRefAndCopy\n";
}

int main() {
	Info x(10);
	std::cout << "---\n";
	takeValue(x);
	std::cout << "---\n";
	takeValue(Info(20)); // or: takeValue(20);
	std::cout << "---\n";
	takeRefAndCopy(x);
	std::cout << "---\n";
	takeRefAndCopy(Info(30));
	std::cout << "---\n";
}
