#include <fstream>
#include <iostream>
#include <string>

void create_file() {
	std::ofstream output("some_file.txt");
	output << "Hello, world!\n";
	for (int i = 0; i < 10; ++i) {
		output << i << ' ';
	}
	output << '\n';
	// output is automatically closed at the end of scope
}

int main() {
	create_file();

	std::ifstream bad_input("nonexistent_file.txt");
	if (!bad_input) {
		std::cout << "File does not exist.\n";
	}

	std::ifstream input("some_file.txt");
	std::string line;
	std::getline(input, line);
	std::cout << "Line: " << line << '\n';

	int num;
	while (input >> num) {
		std::cout << "Num: " << num << '\n';
	}
	// input is automatically closed at the end of scope
}
