#include <fstream>
#include <iostream>
#include <sstream>

void create_file() {
	std::ofstream output("some_file.txt");
	output << "Hello, world!\n";
}

void read_words(std::istream& in) {
	std::string word;
	while (in >> word) {
		std::cout << "WORD: " << word << '\n';
	}
}

int main() {
	create_file();

	std::cout << "Read from file:\n";
	std::ifstream file_in("some_file.txt");
	read_words(file_in);

	std::cout << "\nRead from stringstream:\n";
	std::istringstream string_in("Here are some words...");
	read_words(string_in);

	std::cout << "\nRead from std::cin:\n";
	read_words(std::cin);
	// to close standard input, use Ctrl-D on unix-like systems
}
